cereal::detail::PolymorphicCaster Struct Referenceabstract

Base type for polymorphic void casting. More...

`#include </home/shane/workspace/cereal/include/cereal/details/polymorphic_impl.hpp>`

Inheritance diagram for cereal::detail::PolymorphicCaster:

## Public Member Functions

| PolymorphicCaster (const PolymorphicCaster &)=default
PolymorphicCaster & | operator= (const PolymorphicCaster &)=default
| PolymorphicCaster (PolymorphicCaster &&) CEREAL_NOEXCEPT
PolymorphicCaster & | operator= (PolymorphicCaster &&) CEREAL_NOEXCEPT
virtual const void * | downcast (void const *const ptr) const =0
| Downcasts to the proper derived type.
virtual void * | upcast (void *const ptr) const =0
| Upcast to proper base type.
virtual std::shared_ptr< void > | upcast (std::shared_ptr< void > const &ptr) const =0
| Upcast to proper base type, shared_ptr version.

## Detailed Description

Base type for polymorphic void casting.

Contains functions for casting between registered base and derived types.

This is necessary so that cereal can properly cast between polymorphic types even though void pointers are used, which normally have no type information. Runtime type information is used instead to index a compile-time made mapping that can perform the proper cast. In the case of multiple levels of inheritance, cereal will attempt to find the shortest path by using registered relationships to perform the cast.

This class will be allocated as a StaticObject and only referenced by pointer, allowing a templated derived version of it to define strongly typed functions that cast between registered base and derived types.

The documentation for this struct was generated from the following file:

- /home/shane/workspace/cereal/include/cereal/details/polymorphic_impl.hpp